%global goipath         github.com/caddyserver/caddy

Name:           caddy
Version:        2.7.5
Release:        2%{?dist}
Summary:        Web server with automatic HTTPS
License:        Apache-2.0 AND BSD-2-Clause AND BSD-3-Clause AND MIT AND BSD-2-Clause-Views AND CC0-1.0 AND ISC AND MPL-2.0
URL:            https://caddyserver.com

ExclusiveArch:  %{golang_arches}

BuildRequires:  go-rpm-macros

Source0:        caddy-%{version}-vendored.tar.gz

Source10:       Caddyfile
Source20:       caddy.service
Source21:       caddy-api.service
Source22:       caddy.sysusers
Source30:       poweredby-white.png
Source31:       poweredby-black.png

Patch0:         0001-Disable-commands-that-can-alter-the-binary.patch

BuildRequires:  golang >= 1.20

Provides:       bundled(golang(filippo.io/edwards25519)) = 1.0.0
Provides:       bundled(golang(github.com/AndreasBriese/bbloom)) = 46b345b
Provides:       bundled(golang(github.com/BurntSushi/toml)) = 1.3.2
Provides:       bundled(golang(github.com/Masterminds/goutils)) = 1.1.1
Provides:       bundled(golang(github.com/Masterminds/semver/v3)) = 3.2.0
Provides:       bundled(golang(github.com/Masterminds/sprig/v3)) = 3.2.3
Provides:       bundled(golang(github.com/Microsoft/go-winio)) = 0.6.0
Provides:       bundled(golang(github.com/alecthomas/chroma/v2)) = 2.9.1
Provides:       bundled(golang(github.com/antlr/antlr4/runtime/Go/antlr/v4)) = 8188dc5
Provides:       bundled(golang(github.com/aryann/difflib)) = ff5ff6d
Provides:       bundled(golang(github.com/beorn7/perks)) = 1.0.1
Provides:       bundled(golang(github.com/caddyserver/certmagic)) = 0.19.2
Provides:       bundled(golang(github.com/cenkalti/backoff/v4)) = 4.2.1
Provides:       bundled(golang(github.com/cespare/xxhash)) = 1.1.0
Provides:       bundled(golang(github.com/cespare/xxhash/v2)) = 2.2.0
Provides:       bundled(golang(github.com/chzyer/readline)) = 1.5.1
Provides:       bundled(golang(github.com/cpuguy83/go-md2man/v2)) = 2.0.2
Provides:       bundled(golang(github.com/davecgh/go-spew)) = 1.1.1
Provides:       bundled(golang(github.com/dgraph-io/badger)) = 1.6.2
Provides:       bundled(golang(github.com/dgraph-io/badger/v2)) = 2.2007.4
Provides:       bundled(golang(github.com/dgraph-io/ristretto)) = 0.1.0
Provides:       bundled(golang(github.com/dgryski/go-farm)) = a6ae236
Provides:       bundled(golang(github.com/dlclark/regexp2)) = 1.10.0
Provides:       bundled(golang(github.com/dustin/go-humanize)) = 1.0.1
Provides:       bundled(golang(github.com/felixge/httpsnoop)) = 1.0.3
Provides:       bundled(golang(github.com/fxamacker/cbor/v2)) = 2.5.0
Provides:       bundled(golang(github.com/go-chi/chi)) = 4.1.2+incompatible
Provides:       bundled(golang(github.com/go-chi/chi/v5)) = 5.0.10
Provides:       bundled(golang(github.com/go-kit/kit)) = 0.10.0
Provides:       bundled(golang(github.com/go-logfmt/logfmt)) = 0.5.1
Provides:       bundled(golang(github.com/go-logr/logr)) = 1.2.4
Provides:       bundled(golang(github.com/go-logr/stdr)) = 1.2.2
Provides:       bundled(golang(github.com/go-sql-driver/mysql)) = 1.7.1
Provides:       bundled(golang(github.com/go-task/slim-sprig)) = 52ccab3
Provides:       bundled(golang(github.com/golang/glog)) = 1.1.0
Provides:       bundled(golang(github.com/golang/protobuf)) = 1.5.3
Provides:       bundled(golang(github.com/golang/snappy)) = 0.0.4
Provides:       bundled(golang(github.com/google/cel-go)) = 0.15.1
Provides:       bundled(golang(github.com/google/certificate-transparency-go)) = 1.1.6
Provides:       bundled(golang(github.com/google/go-tpm)) = 0.9.0
Provides:       bundled(golang(github.com/google/go-tspi)) = 0.3.0
Provides:       bundled(golang(github.com/google/pprof)) = 4bb14d4
Provides:       bundled(golang(github.com/google/uuid)) = 1.3.1
Provides:       bundled(golang(github.com/grpc-ecosystem/grpc-gateway/v2)) = 2.15.2
Provides:       bundled(golang(github.com/huandu/xstrings)) = 1.3.3
Provides:       bundled(golang(github.com/imdario/mergo)) = 0.3.12
Provides:       bundled(golang(github.com/inconshreveable/mousetrap)) = 1.1.0
Provides:       bundled(golang(github.com/jackc/chunkreader/v2)) = 2.0.1
Provides:       bundled(golang(github.com/jackc/pgconn)) = 1.14.0
Provides:       bundled(golang(github.com/jackc/pgio)) = 1.0.0
Provides:       bundled(golang(github.com/jackc/pgpassfile)) = 1.0.0
Provides:       bundled(golang(github.com/jackc/pgproto3/v2)) = 2.3.2
Provides:       bundled(golang(github.com/jackc/pgservicefile)) = 091c0ba
Provides:       bundled(golang(github.com/jackc/pgtype)) = 1.14.0
Provides:       bundled(golang(github.com/jackc/pgx/v4)) = 4.18.0
Provides:       bundled(golang(github.com/klauspost/compress)) = 1.17.0
Provides:       bundled(golang(github.com/klauspost/cpuid/v2)) = 2.2.5
Provides:       bundled(golang(github.com/libdns/libdns)) = 0.2.1
Provides:       bundled(golang(github.com/manifoldco/promptui)) = 0.9.0
Provides:       bundled(golang(github.com/mastercactapus/proxyprotocol)) = 0.0.4
Provides:       bundled(golang(github.com/mattn/go-colorable)) = 0.1.8
Provides:       bundled(golang(github.com/mattn/go-isatty)) = 0.0.16
Provides:       bundled(golang(github.com/matttproud/golang_protobuf_extensions)) = 1.0.4
Provides:       bundled(golang(github.com/mgutz/ansi)) = d51e80e
Provides:       bundled(golang(github.com/mholt/acmez)) = 1.2.0
Provides:       bundled(golang(github.com/micromdm/scep/v2)) = 2.1.0
Provides:       bundled(golang(github.com/miekg/dns)) = 1.1.55
Provides:       bundled(golang(github.com/mitchellh/copystructure)) = 1.2.0
Provides:       bundled(golang(github.com/mitchellh/go-ps)) = 1.0.0
Provides:       bundled(golang(github.com/mitchellh/reflectwalk)) = 1.0.2
Provides:       bundled(golang(github.com/onsi/ginkgo/v2)) = 2.9.5
Provides:       bundled(golang(github.com/pkg/errors)) = 0.9.1
Provides:       bundled(golang(github.com/pmezard/go-difflib)) = 1.0.0
Provides:       bundled(golang(github.com/prometheus/client_golang)) = 1.15.1
Provides:       bundled(golang(github.com/prometheus/client_model)) = 0.4.0
Provides:       bundled(golang(github.com/prometheus/common)) = 0.42.0
Provides:       bundled(golang(github.com/prometheus/procfs)) = 0.9.0
Provides:       bundled(golang(github.com/quic-go/qpack)) = 0.4.0
Provides:       bundled(golang(github.com/quic-go/qtls-go1-20)) = 0.3.4
Provides:       bundled(golang(github.com/quic-go/quic-go)) = 0.39.0
Provides:       bundled(golang(github.com/rs/xid)) = 1.5.0
Provides:       bundled(golang(github.com/russross/blackfriday/v2)) = 2.1.0
Provides:       bundled(golang(github.com/shopspring/decimal)) = 1.2.0
Provides:       bundled(golang(github.com/shurcooL/sanitized_anchor_name)) = 1.0.0
Provides:       bundled(golang(github.com/sirupsen/logrus)) = 1.9.3
Provides:       bundled(golang(github.com/slackhq/nebula)) = 1.6.1
Provides:       bundled(golang(github.com/smallstep/certificates)) = 0.25.0
Provides:       bundled(golang(github.com/smallstep/go-attestation)) = cf579e5
Provides:       bundled(golang(github.com/smallstep/nosql)) = 0.6.0
Provides:       bundled(golang(github.com/smallstep/truststore)) = 0.12.1
Provides:       bundled(golang(github.com/spf13/cast)) = 1.4.1
Provides:       bundled(golang(github.com/spf13/cobra)) = 1.7.0
Provides:       bundled(golang(github.com/spf13/pflag)) = 1.0.5
Provides:       bundled(golang(github.com/stoewer/go-strcase)) = 1.2.0
Provides:       bundled(golang(github.com/stretchr/testify)) = 1.8.4
Provides:       bundled(golang(github.com/tailscale/tscert)) = 28a91b6
Provides:       bundled(golang(github.com/urfave/cli)) = 1.22.14
Provides:       bundled(golang(github.com/x448/float16)) = 0.8.4
Provides:       bundled(golang(github.com/yuin/goldmark)) = 1.5.6
Provides:       bundled(golang(github.com/yuin/goldmark-highlighting/v2)) = 37449ab
Provides:       bundled(golang(github.com/zeebo/blake3)) = 0.2.3
Provides:       bundled(golang(go.etcd.io/bbolt)) = 1.3.7
Provides:       bundled(golang(go.mozilla.org/pkcs7)) = 33d0574
Provides:       bundled(golang(go.opentelemetry.io/contrib/instrumentation/net/http/otelhttp)) = 0.42.0
Provides:       bundled(golang(go.opentelemetry.io/contrib/propagators/autoprop)) = 0.42.0
Provides:       bundled(golang(go.opentelemetry.io/contrib/propagators/aws)) = 1.17.0
Provides:       bundled(golang(go.opentelemetry.io/contrib/propagators/b3)) = 1.17.0
Provides:       bundled(golang(go.opentelemetry.io/contrib/propagators/jaeger)) = 1.17.0
Provides:       bundled(golang(go.opentelemetry.io/contrib/propagators/ot)) = 1.17.0
Provides:       bundled(golang(go.opentelemetry.io/otel)) = 1.16.0
Provides:       bundled(golang(go.opentelemetry.io/otel/exporters/otlp/internal/retry)) = 1.16.0
Provides:       bundled(golang(go.opentelemetry.io/otel/exporters/otlp/otlptrace)) = 1.16.0
Provides:       bundled(golang(go.opentelemetry.io/otel/exporters/otlp/otlptrace/otlptracegrpc)) = 1.16.0
Provides:       bundled(golang(go.opentelemetry.io/otel/metric)) = 1.16.0
Provides:       bundled(golang(go.opentelemetry.io/otel/sdk)) = 1.16.0
Provides:       bundled(golang(go.opentelemetry.io/otel/trace)) = 1.16.0
Provides:       bundled(golang(go.opentelemetry.io/proto/otlp)) = 0.19.0
Provides:       bundled(golang(go.step.sm/cli-utils)) = 0.8.0
Provides:       bundled(golang(go.step.sm/crypto)) = 0.35.1
Provides:       bundled(golang(go.step.sm/linkedca)) = 0.20.1
Provides:       bundled(golang(go.uber.org/mock)) = 0.3.0
Provides:       bundled(golang(go.uber.org/multierr)) = 1.11.0
Provides:       bundled(golang(go.uber.org/zap)) = 1.25.0
Provides:       bundled(golang(golang.org/x/crypto)) = 0.14.0
Provides:       bundled(golang(golang.org/x/exp)) = 522b1b5
Provides:       bundled(golang(golang.org/x/mod)) = 0.11.0
Provides:       bundled(golang(golang.org/x/net)) = 0.17.0
Provides:       bundled(golang(golang.org/x/sync)) = 0.4.0
Provides:       bundled(golang(golang.org/x/sys)) = 0.13.0
Provides:       bundled(golang(golang.org/x/term)) = 0.13.0
Provides:       bundled(golang(golang.org/x/text)) = 0.13.0
Provides:       bundled(golang(golang.org/x/tools)) = 0.10.0
Provides:       bundled(golang(google.golang.org/genproto)) = 007df8e
Provides:       bundled(golang(google.golang.org/genproto/googleapis/api)) = f966b18
Provides:       bundled(golang(google.golang.org/genproto/googleapis/rpc)) = e6e6cda
Provides:       bundled(golang(google.golang.org/grpc)) = 1.58.2
Provides:       bundled(golang(google.golang.org/protobuf)) = 1.31.0
Provides:       bundled(golang(gopkg.in/natefinch/lumberjack.v2)) = 2.2.1
Provides:       bundled(golang(gopkg.in/square/go-jose.v2)) = 2.6.0
Provides:       bundled(golang(gopkg.in/yaml.v3)) = 3.0.1
Provides:       bundled(golang(howett.net/plist)) = 1.0.0

BuildRequires:  systemd-rpm-macros
%{?systemd_requires}
%{?sysusers_requires_compat}
Requires:       system-logos-httpd
Provides:       webserver


%description
Caddy is the web server with automatic HTTPS.


%prep
%autosetup -p 1
mkdir -p src/$(dirname %{goipath})
ln -s $PWD src/%{goipath}


%build
export GO111MODULE=off
export GOPATH=$PWD
export LDFLAGS="-X %{goipath}.CustomVersion=v%{version}"
%gobuild -o bin/caddy %{goipath}/cmd/caddy


%install
install -D -p -m 0755 bin/caddy %{buildroot}%{_bindir}/caddy

./bin/caddy manpage --directory %{buildroot}%{_mandir}/man8

install -D -p -m 0644 %{S:10} %{buildroot}%{_sysconfdir}/caddy/Caddyfile
install -d -m 0755 %{buildroot}%{_sysconfdir}/caddy/Caddyfile.d

install -D -p -m 0644 %{S:20} %{buildroot}%{_unitdir}/caddy.service
install -D -p -m 0644 %{S:21} %{buildroot}%{_unitdir}/caddy-api.service

install -D -p -m 0644 %{S:22} %{buildroot}%{_sysusersdir}/caddy.conf

install -d -m 0750 %{buildroot}%{_sharedstatedir}/caddy

install -D -p -m 0644 %{S:31} %{buildroot}%{_datadir}/caddy/poweredby.png
ln -s ../testpage/index.html %{buildroot}%{_datadir}/caddy/index.html
install -d -m 0755 %{buildroot}%{_datadir}/caddy/icons
ln -s ../../pixmaps/poweredby.png %{buildroot}%{_datadir}/caddy/icons/poweredby.png
ln -s ../pixmaps/system-noindex-logo.png %{buildroot}%{_datadir}/caddy/system_noindex_logo.png

install -d -m 0755 %{buildroot}%{_datadir}/bash-completion/completions
./bin/caddy completion bash > %{buildroot}%{_datadir}/bash-completion/completions/caddy
install -d -m 0755 %{buildroot}%{_datadir}/zsh/site-functions
./bin/caddy completion zsh > %{buildroot}%{_datadir}/zsh/site-functions/_caddy
install -d -m 0755 %{buildroot}%{_datadir}/fish/vendor_completions.d
./bin/caddy completion fish > %{buildroot}%{_datadir}/fish/vendor_completions.d/caddy.fish


%check
[[ "$(./bin/caddy version)" == "v%{version}" ]] || exit 1

export GOPATH=$PWD
cd src/%{goipath}
%gotest ./...


%pre
%sysusers_create_compat %{S:22}


%post
%systemd_post caddy.service

if [ -x /usr/sbin/getsebool ]; then
    setsebool -P httpd_can_network_connect on
fi
if [ -x /usr/sbin/semanage -a -x /usr/sbin/restorecon ]; then
    semanage fcontext --add --type httpd_exec_t        '%{_bindir}/caddy'               2> /dev/null || :
    semanage fcontext --add --type httpd_sys_content_t '%{_datadir}/caddy(/.*)?'        2> /dev/null || :
    semanage fcontext --add --type httpd_config_t      '%{_sysconfdir}/caddy(/.*)?'     2> /dev/null || :
    semanage fcontext --add --type httpd_var_lib_t     '%{_sharedstatedir}/caddy(/.*)?' 2> /dev/null || :
    restorecon -r %{_bindir}/caddy %{_datadir}/caddy %{_sysconfdir}/caddy %{_sharedstatedir}/caddy || :
fi
if [ -x /usr/sbin/semanage ]; then
    semanage port --add --type http_port_t --proto udp 80   2> /dev/null || :
    semanage port --add --type http_port_t --proto udp 443  2> /dev/null || :
    semanage port --add --type http_port_t --proto tcp 2019 2> /dev/null || :
fi


%preun
%systemd_preun caddy.service


%postun
%systemd_postun_with_restart caddy.service

if [ $1 -eq 0 ]; then
    if [ -x /usr/sbin/getsebool ]; then
        setsebool -P httpd_can_network_connect off
    fi
    if [ -x /usr/sbin/semanage ]; then
        semanage fcontext --delete --type httpd_exec_t        '%{_bindir}/caddy'               2> /dev/null || :
        semanage fcontext --delete --type httpd_sys_content_t '%{_datadir}/caddy(/.*)?'        2> /dev/null || :
        semanage fcontext --delete --type httpd_config_t      '%{_sysconfdir}/caddy(/.*)?'     2> /dev/null || :
        semanage fcontext --delete --type httpd_var_lib_t     '%{_sharedstatedir}/caddy(/.*)?' 2> /dev/null || :
        semanage port     --delete --type http_port_t --proto udp 80   2> /dev/null || :
        semanage port     --delete --type http_port_t --proto udp 443  2> /dev/null || :
        semanage port     --delete --type http_port_t --proto tcp 2019 2> /dev/null || :
    fi
fi


%files
%license LICENSE
%doc README.md AUTHORS
%{_bindir}/caddy
%{_mandir}/man8/caddy*.8*
%{_datadir}/caddy
%{_unitdir}/caddy.service
%{_unitdir}/caddy-api.service
%{_sysusersdir}/caddy.conf
%dir %{_sysconfdir}/caddy
%config(noreplace) %{_sysconfdir}/caddy/Caddyfile
%dir %{_sysconfdir}/caddy/Caddyfile.d
%attr(0750,caddy,caddy) %dir %{_sharedstatedir}/caddy
%{_datadir}/bash-completion/completions/caddy
%{_datadir}/zsh/site-functions/_caddy
%{_datadir}/fish/vendor_completions.d/caddy.fish


%changelog
* Wed Apr 24 2024 OpenCloudOS Release Engineering <releng@opencloudos.tech> - 2.7.5-2
- rebase to add ocs and ts macros

* Thu Apr 11 2024 OpenCloudOS Release Engineering <releng@opencloudos.tech> - 2.7.5-1
- initial build
